aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorB. Watson <urchlay@slackware.uk>2025-03-18 23:49:59 -0400
committerB. Watson <urchlay@slackware.uk>2025-03-18 23:49:59 -0400
commitf7185ad2e28fb3dcc42b9cc28e94cb456bbc3653 (patch)
treebed40cac1426adc849c6a8b4f3f4d8108a319741
parent790e4165e553c2006b64a76c5441442c6867f54d (diff)
downloadbw-atari8-tools-f7185ad2e28fb3dcc42b9cc28e94cb456bbc3653.tar.gz
abas2html: added.
-rw-r--r--Makefile4
-rwxr-xr-xabas2html106
-rw-r--r--abas2html.1168
-rw-r--r--abas2html.rst86
4 files changed, 362 insertions, 2 deletions
diff --git a/Makefile b/Makefile
index ed99125..ce1233b 100644
--- a/Makefile
+++ b/Makefile
@@ -21,8 +21,8 @@ CFLAGS=-Wall $(COPT) -ansi -D_GNU_SOURCE -DVERSION=\"$(VERSION)\"
# BINS and SCRIPTS go in $BINDIR, DOCS go in $DOCDIR
BINS=a8eol atr2xfd atrsize axe blob2c blob2xex cart2xex cxrefbas dumpbas fenders protbas renumbas rom2cart unmac65 unprotbas vxrefbas xex1to2 xexamine xexcat xexsplit xfd2atr listbas a8cat a8xd whichbas bas2aplus listamsb
-SCRIPTS=dasm2atasm diffbas a8diff colorize-amsb
-MANS=a8eol.1 xfd2atr.1 atr2xfd.1 blob2c.1 cart2xex.1 fenders.1 xexsplit.1 xexcat.1 atrsize.1 rom2cart.1 unmac65.1 axe.1 dasm2atasm.1 blob2xex.1 xexamine.1 xex1to2.1 unprotbas.1 protbas.1 renumbas.1 dumpbas.1 vxrefbas.1 cxrefbas.1 listbas.1 a8cat.1 a8xd.1 whichbas.1 diffbas.1 a8diff.1 bas2aplus.1 listamsb.1 colorize-amsb.1
+SCRIPTS=dasm2atasm diffbas a8diff colorize-amsb abas2html
+MANS=a8eol.1 xfd2atr.1 atr2xfd.1 blob2c.1 cart2xex.1 fenders.1 xexsplit.1 xexcat.1 atrsize.1 rom2cart.1 unmac65.1 axe.1 dasm2atasm.1 blob2xex.1 xexamine.1 xex1to2.1 unprotbas.1 protbas.1 renumbas.1 dumpbas.1 vxrefbas.1 cxrefbas.1 listbas.1 a8cat.1 a8xd.1 whichbas.1 diffbas.1 a8diff.1 bas2aplus.1 listamsb.1 colorize-amsb.1 abas2html.1
MAN5S=xex.5
MAN7S=atascii.7 fauxtari.7 amsb.7
DOCS=README.txt CHANGES.txt equates.inc *.dasm LICENSE ksiders/atr.txt
diff --git a/abas2html b/abas2html
new file mode 100755
index 0000000..e2f82ee
--- /dev/null
+++ b/abas2html
@@ -0,0 +1,106 @@
+#!/bin/sh
+
+# this is supposed to be POSIX sh compliant. their getopts docs:
+# https://pubs.opengroup.org/onlinepubs/9699919799/utilities/getopts.html
+
+SELF="$( echo $0 | sed 's,.*/,,' )"
+
+die() {
+ echo "$SELF: $1" >& 2
+ exit 1
+}
+
+checkbin() {
+ if ! which "$1" >/dev/null 2>/dev/null; then
+ die "$1 not found on PATH, can't continue"
+ fi
+}
+
+print_help() {
+ cat <<EOF
+$SELF: convert tokenized Atari BASIC to HTML
+B. Watson <urchlay@slackware.uk>, WTFPL
+Usage: $SELF -a<aha-options> -b<basver> -m input.bas <output.html>
+ -a next option is passed to aha(1). may be used multiple times.
+ -b set BASIC dialect. default is autodetection. valid dialects:
+ -ba Atari 8K BASIC
+ -ba+ OSS BASIC/A+
+ -bm Atari Microsoft BASIC
+ -bt Turbo BASIC XL
+ -bxl OSS BASIC XL
+ -bxe OSS BASIC XE
+ -m monochrome: disable color syntax highlighting.
+if output filename is missing, it defaults to the input filename, with
+the extension changed to .html (e.g. FOO.BAS => FOO.html).
+EOF
+ exit $1
+}
+
+# main()
+if [ "$*" = "--help" ]; then
+ print_help 0
+fi
+
+while getopts ":hb:a:mMn" opt; do
+ case "$opt" in
+ b) BASVER="$OPTARG" ;;
+ a) AHA_OPTS="$AHA_OPTS $OPTARG" ;;
+ m|M|n) MONO="1" ;;
+ h) print_help 0 ;;
+ *) die "invalid option -$OPTARG" ;;
+ esac
+done
+
+shift $(($OPTIND - 1))
+
+if [ -z "$1" ]; then
+ die "no input file given (try -h)"
+else
+ infile="$1"
+fi
+
+if [ -n "$2" ]; then
+ outfile="$2"
+else
+ outfile="$( echo "$infile" | sed 's,\.[^.]*$,.html,' )"
+ if [ "$infile" = "$outfile" ]; then
+ outfile="$infile".html
+ fi
+fi
+
+if [ "$BASVER" = "" ]; then
+ checkbin whichbas
+ whichbas -s "$infile"
+ case "$?" in
+ 3) BASVER="a" ;;
+ 4|7|8|9) BASVER="t" ;;
+ 5) BASVER="xl" ;;
+ 6|12) BASVER="xe" ;;
+ 11) BASVER="m" ;;
+ 14) BASVER="a+" ;;
+ *) die "can't detect BASIC dialect; use -b<xx> option" ;;
+ esac
+fi
+
+case "$BASVER" in
+ m) LISTER=listamsb ; BASVER="" ;;
+ a|t|xl|xe|a+) LISTER=listbas ; BASVER="-b$BASVER" ;;
+ *) die "$BASVER not a valid BASIC dialect" ;;
+esac
+
+checkbin $LISTER
+checkbin aha
+if [ "$LISTER" = "listamsb" ]; then
+ checkbin a8cat
+ if [ "$MONO" = "1" ]; then
+ MONO_OPT="-M"
+ else
+ checkbin colorize-amsb
+ fi
+else
+ if [ "$MONO" = "1" ]; then
+ MONO_OPT="-n"
+ fi
+fi
+
+exec $LISTER $BASVER $MONO_OPT "$infile" | aha -t "$infile" $AHA_OPTS > "$outfile"
diff --git a/abas2html.1 b/abas2html.1
new file mode 100644
index 0000000..65deaaf
--- /dev/null
+++ b/abas2html.1
@@ -0,0 +1,168 @@
+.\" Man page generated from reStructuredText.
+.
+.
+.nr rst2man-indent-level 0
+.
+.de1 rstReportMargin
+\\$1 \\n[an-margin]
+level \\n[rst2man-indent-level]
+level margin: \\n[rst2man-indent\\n[rst2man-indent-level]]
+-
+\\n[rst2man-indent0]
+\\n[rst2man-indent1]
+\\n[rst2man-indent2]
+..
+.de1 INDENT
+.\" .rstReportMargin pre:
+. RS \\$1
+. nr rst2man-indent\\n[rst2man-indent-level] \\n[an-margin]
+. nr rst2man-indent-level +1
+.\" .rstReportMargin post:
+..
+.de UNINDENT
+. RE
+.\" indent \\n[an-margin]
+.\" old: \\n[rst2man-indent\\n[rst2man-indent-level]]
+.nr rst2man-indent-level -1
+.\" new: \\n[rst2man-indent\\n[rst2man-indent-level]]
+.in \\n[rst2man-indent\\n[rst2man-indent-level]]u
+..
+.TH "ABAS2HTML" 1 "2025-03-18" "0.2.2" "Urchlay's Atari 8-bit Tools"
+.SH NAME
+abas2html \- Create HTML from tokenized Atari BASIC
+.SH SYNOPSIS
+.sp
+\fBabas2html\fP [\fB\-h\fP] [\fB\-a\fP \fIaha\-opts\fP] [\fB\-b\fP \fIdialect\fP] [\fB\-m\fP] \fIinput\-file\fP [\fIoutput\-file\fP]
+.SH DESCRIPTION
+.sp
+\fBabas2html\fP is a shell script wrapper for \fBlistbas\fP(1),
+\fBlistamsb\fP(1), and \fBaha\fP(1). It creates an HTML file of the
+program listing, with color syntax highlighting by default. ATASCII
+characters are converted to Unicode equivalents, and inverse video is
+displayed correctly.
+.sp
+\fIinput\-file\fP must be a tokenized BASIC program, either Atari 8K BASIC,
+OSS BASIC/A+, Atari Microsoft BASIC, Turbo BASIC XL, OSS BASIC XL, or
+OSS BASIC XE. You can specify the BASIC dialect (see \fB\-b\fP, below) or
+let it be autodetected (via \fBwhichbas\fP(1)).
+.sp
+\fIoutput\-file\fP will be an HTML file, created by \fBaha\fP(1). If
+no output filename is given, it will be costructed by changing the
+filename extension to \fI\&.html\fP, or (if there is no extension) by adding
+\fI\&.html\fP to the input filename.
+.sp
+\fBaha\fP can be installed from \fI\%https://github.com/theZiz/aha\fP or from
+your distribution\(aqs package repository (e.g. \fBsbopkg \-i aha\fP on Slackware,
+\fBapt install aha\fP on Debian or Ubuntu).
+.SH OPTIONS
+.INDENT 0.0
+.TP
+.B \-a
+Next option is passed to \fBaha\fP(1). May be used multiple times.
+Examples:
+.INDENT 7.0
+.INDENT 3.5
+.sp
+.nf
+.ft C
+abas2html \-a \-b \-a \-n FOO.BAS # black background, no header
+abas2html \-a"\-b \-n" FOO.BAS # same thing, quotes required
+.ft P
+.fi
+.UNINDENT
+.UNINDENT
+.TP
+.B \-b
+Set BASIC dialect. Default is autodetection. Valid dialects:
+.sp
+\fB\-ba\fP Atari 8K BASIC
+.sp
+\fB\-ba+\fP OSS BASIC/A+
+.sp
+\fB\-bm\fP Atari Microsoft BASIC
+.sp
+\fB\-bt\fP Turbo BASIC XL
+.sp
+\fB\-bxl\fP OSS BASIC XL
+.sp
+\fB\-bxe\fP OSS BASIC XE
+.TP
+.B \-m
+Monochrome: disable color syntax highlighting.
+.UNINDENT
+.SH ENVIRONMENT
+.INDENT 0.0
+.TP
+.B \fBPATH\fP
+The various programs executed are searched for in \fBPATH\fP\&. If you don\(aqt
+have the utilities installed system\-wide, you can use something like:
+.INDENT 7.0
+.INDENT 3.5
+.sp
+.nf
+.ft C
+PATH=.:$PATH ./abas2html <...>
+.ft P
+.fi
+.UNINDENT
+.UNINDENT
+.TP
+.B \fBLISTBAS_OPTS\fP
+See \fBlistbas\fP(1) for usage. Note that Atari Microsoft BASIC programs
+are listed with \fBlistamsb\fP, which is not affected by this environment
+variable.
+.TP
+.B \fBA8CAT\fP, \fBCOLORIZE_AMSB\fP
+Used by \fBlistamsb\fP(1) when listing Atari Microsoft BASIC programs.
+.UNINDENT
+.SH EXIT STATUS
+.sp
+0 for success, non\-zero for failure.
+.SH COPYRIGHT
+.sp
+WTFPL. See \fI\%http://www.wtfpl.net/txt/copying/\fP for details.
+.SH AUTHOR
+.INDENT 0.0
+.IP B. 3
+Watson <\fI\%urchlay@slackware.uk\fP>; Urchlay on irc.libera.chat \fI##atari\fP\&.
+.UNINDENT
+.SH SEE ALSO
+.sp
+\fBa8cat\fP(1),
+\fBa8eol\fP(1),
+\fBa8xd\fP(1),
+\fBatr2xfd\fP(1),
+\fBatrsize\fP(1),
+\fBaxe\fP(1),
+\fBbas2aplus\fP(1),
+\fBblob2c\fP(1),
+\fBblob2xex\fP(1),
+\fBcart2xex\fP(1),
+\fBcxrefbas\fP(1),
+\fBdasm2atasm\fP(1),
+\fBdiffbas\fP(1),
+\fBdumpbas\fP(1),
+\fBf2toxex\fP(1),
+\fBfenders\fP(1),
+\fBlistbas\fP(1),
+\fBlistamsb\fP(1),
+\fBprotbas\fP(1),
+\fBrenumbas\fP(1),
+\fBrom2cart\fP(1),
+\fBunmac65\fP(1),
+\fBunprotbas\fP(1),
+\fBvxrefbas\fP(1),
+\fBwhichbas\fP(1),
+\fBxex1to2\fP(1),
+\fBxexamine\fP(1),
+\fBxexcat\fP(1),
+\fBxexsplit\fP(1),
+\fBxfd2atr\fP(1),
+\fBxex\fP(5),
+\fBatascii\fP(7),
+\fBfauxtari\fP(7).
+.sp
+Any good Atari 8\-bit book: \fIDe Re Atari\fP, \fIThe Atari BASIC Reference
+Manual\fP, the \fIOS Users\(aq Guide\fP, \fIMapping the Atari\fP, etc.
+.\" Generated by docutils manpage writer.
+.
diff --git a/abas2html.rst b/abas2html.rst
new file mode 100644
index 0000000..7085756
--- /dev/null
+++ b/abas2html.rst
@@ -0,0 +1,86 @@
+=========
+abas2html
+=========
+
+--------------------------------------
+Create HTML from tokenized Atari BASIC
+--------------------------------------
+
+.. include:: manhdr.rst
+
+SYNOPSIS
+========
+
+**abas2html** [**-h**] [**-a** *aha-opts*] [**-b** *dialect*] [**-m**] *input-file* [*output-file*]
+
+DESCRIPTION
+===========
+
+**abas2html** is a shell script wrapper for **listbas**\(1),
+**listamsb**\(1), and **aha**\(1). It creates an HTML file of the
+program listing, with color syntax highlighting by default. ATASCII
+characters are converted to Unicode equivalents, and inverse video is
+displayed correctly.
+
+*input-file* must be a tokenized BASIC program, either Atari 8K BASIC,
+OSS BASIC/A+, Atari Microsoft BASIC, Turbo BASIC XL, OSS BASIC XL, or
+OSS BASIC XE. You can specify the BASIC dialect (see **-b**, below) or
+let it be autodetected (via **whichbas**\(1)).
+
+*output-file* will be an HTML file, created by **aha**\(1). If
+no output filename is given, it will be costructed by changing the
+filename extension to *.html*, or (if there is no extension) by adding
+*.html* to the input filename.
+
+**aha** can be installed from https://github.com/theZiz/aha or from
+your distribution's package repository (e.g. **sbopkg -i aha** on Slackware,
+**apt install aha** on Debian or Ubuntu).
+
+OPTIONS
+=======
+
+-a Next option is passed to **aha**\(1). May be used multiple times.
+ Examples::
+
+ abas2html -a -b -a -n FOO.BAS # black background, no header
+ abas2html -a"-b -n" FOO.BAS # same thing, quotes required
+
+-b Set BASIC dialect. Default is autodetection. Valid dialects:
+
+ **-ba** Atari 8K BASIC
+
+ **-ba+** OSS BASIC/A+
+
+ **-bm** Atari Microsoft BASIC
+
+ **-bt** Turbo BASIC XL
+
+ **-bxl** OSS BASIC XL
+
+ **-bxe** OSS BASIC XE
+
+-m Monochrome: disable color syntax highlighting.
+
+ENVIRONMENT
+===========
+
+**PATH**
+ The various programs executed are searched for in **PATH**. If you don't
+ have the utilities installed system-wide, you can use something like::
+
+ PATH=.:$PATH ./abas2html <...>
+
+**LISTBAS_OPTS**
+ See **listbas**\(1) for usage. Note that Atari Microsoft BASIC programs
+ are listed with **listamsb**, which is not affected by this environment
+ variable.
+
+**A8CAT**\, **COLORIZE_AMSB**
+ Used by **listamsb**\(1) when listing Atari Microsoft BASIC programs.
+
+EXIT STATUS
+===========
+
+0 for success, non-zero for failure.
+
+.. include:: manftr.rst